drop table execucao_servico;
drop table centro_medico;
drop table tipo_centro_medico;
drop table servico_contrato;
drop table servico;
drop table tipo_servico;
drop table contrato;
drop table dependente;
drop table beneficiario;
drop table especialidade_medico;
drop table especialidade;
drop table medico;

create table medico (
  cpf numeric(11) PRIMARY KEY,
  nome varchar(100) NOT NULL,
  rg char(10),
  endereco varchar(255),
  telefone char(20),
  crm char(10) UNIQUE
);

create table especialidade(
  codigo char(3) PRIMARY KEY,
  nome varchar(100) NOT NULL
);

create table especialidade_medico(
  cpf_medico numeric(11),
  codigo_especialidade char(3),
  PRIMARY KEY (cpf_medico, codigo_especialidade),
  FOREIGN KEY (cpf_medico) REFERENCES medico (cpf),
  FOREIGN KEY (codigo_especialidade) REFERENCES especialidade (codigo)
);

create table beneficiario (
  cpf numeric(11) PRIMARY KEY,
  nome varchar(100) NOT NULL,
  rg char(10),
  endereco varchar(255),
  telefone char(20)
);

create table dependente (
  codigo char(6) PRIMARY KEY,
  nome char(40) NOT NULL,
  cpf_beneficiario numeric(11),
  data_nascimento date,
  grau_parentesco varchar(30),
  FOREIGN KEY (cpf_beneficiario) REFERENCES beneficiario (cpf)
);

create table contrato (
  numero char(6) NOT NULL,
  cpf_beneficiario numeric(11),
  data_validade date,
  valor_mensalidade numeric(10,2),
  PRIMARY KEY (numero, cpf_beneficiario),
  FOREIGN KEY (cpf_beneficiario) REFERENCES beneficiario (cpf)
);

create table tipo_servico (
  codigo char(3) PRIMARY KEY,
  nome varchar(100) UNIQUE
);

create table servico (
  codigo char(3) PRIMARY KEY,
  descricao varchar(255) NOT NULL,
  valor numeric(10,2),
  codigo_tipo_servico char(3),
  FOREIGN KEY (codigo_tipo_servico) REFERENCES tipo_servico (codigo)
);

create table servico_contrato (
  numero_contrato char(6),
  cpf_beneficiario numeric(11),
  codigo_servico char(3),
  PRIMARY KEY (numero_contrato, cpf_beneficiario, codigo_servico),
  FOREIGN KEY (numero_contrato, cpf_beneficiario) REFERENCES contrato (numero, cpf_beneficiario),
  FOREIGN KEY (codigo_servico) REFERENCES servico (codigo)
);

create table tipo_centro_medico (
  codigo char(3) PRIMARY KEY,
  nome varchar(100) UNIQUE
);

create table centro_medico (
  cgc char(10) PRIMARY KEY,
  nome varchar(100) NOT NULL,
  endereco varchar(255),
  telefone char(20),
  inscricao_estadual char(20),
  codigo_tipo_centro char(3),
  FOREIGN KEY (codigo_tipo_centro) REFERENCES tipo_centro_medico (codigo)
);

create table execucao_servico (
  numero_contrato char(6),
  cpf_beneficiario numeric(11),
  codigo_servico char(3),
  numero_execucao char(5) NOT NULL,
  data date,
  cgc_centro_medico char(10),
  cpf_medico numeric(11),
  codigo_dependente char(6) NULL,
  PRIMARY KEY (numero_contrato, cpf_beneficiario, codigo_servico, numero_execucao),
  FOREIGN KEY (numero_contrato, cpf_beneficiario, codigo_servico) REFERENCES servico_contrato (numero_contrato, cpf_beneficiario, codigo_servico),
  FOREIGN KEY (cgc_centro_medico) REFERENCES centro_medico (cgc),
  FOREIGN KEY (cpf_medico) REFERENCES medico (cpf)
);