package db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

public class BDacesso {
	private static String host=null;
	private static String bancodados=null;
	private static String usuario=null;
	private static String senha=null;
	Connection conexao=null;
	
			
	public BDacesso(){
		try {			
			host = "localhost";
			bancodados = "servicos_medicos";
			usuario = "admin";
			senha = "sipinipis";
			Class.forName("org.postgresql.Driver");
		} catch (ClassNotFoundException cnfe) {
			System.out.println("No foi possvel achar o driver!");
		    System.out.println("Imprimindo o stack trace.");
		    cnfe.printStackTrace();
		    System.exit(1);
		}		
	}
	
	public void conectar(){
		try {
			// The second and third arguments are the username and password,
			// respectively. They should be whatever is necessary to connect to the database.
			conexao = DriverManager.getConnection("jdbc:postgresql://"+host+"/"+bancodados,usuario,senha);
			//System.out.println("+ Conexo estabelecida ao banco de dados: "+bancodados);
		} catch (SQLException se) {
			System.out.println("- No foi possvel fazer a conexo.");
			se.printStackTrace();
			System.exit(1);
		}
	}

	public void fecharConecao(){
		try {
			conexao.close();
		} catch (SQLException se) {
			System.out.println("- No foi possvel fechar a conexo.");
			se.printStackTrace();
			System.exit(1);			
		}
	}
	
	public boolean estaConectado(){
		if(conexao==null) 
			return false;
		try {
			return !conexao.isClosed();
		} catch(SQLException se){
			System.out.println("* Programa no conectado ao banco de dados.");
			return false;
		}
	}
	
	public Statement executarInstrucaoSQL(String instrucaoSQL){
		Statement stmt=null;
		
		if (!estaConectado()) conectar();
		
		try {
			stmt = conexao.createStatement();
		} catch (SQLException se) {
			System.out.println("- Ocorreu um erro criando a instruo: " +
		                       "Provavelmente no est conectado ao banco de dados.");
			se.printStackTrace();
			System.exit(1);
		}
		
		try {
			stmt.execute(instrucaoSQL);
			System.out.println("+ Intruo SQL executada:"+instrucaoSQL);
		} catch (SQLException se) {
			System.out.println("- Ocorreu um erro executando a instruo: " +
							   "provavelmente deva-se a um erro na instrua SQL");
			se.printStackTrace();
			System.exit(1);
		}
		return stmt;
	}
}
