package gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.Rectangle;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.Color;
import logic.Beneficiario;
import logic.Dependente;
import logic.Contrato;
import logic.Servicocontrato;
import logic.Execucaoservico;


public class BeneficiariosConsulta extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jlblBeneficiario = null;
	private JButton jbtnFechar = null;
	private Vector beneficiarios;  //  @jve:decl-index=0:
	private Vector dependentes;    //  @jve:decl-index=0:
	private Vector contratos;      //  @jve:decl-index=0:
	private Vector servicosContrato;      //  @jve:decl-index=0:
	private Vector servicosExecutados;

	private JScrollPane jscpBeneficiario = null;
	private JTable jtblBeneficiario = null;
	private JLabel jlblDependente = null;
	private JScrollPane jscpDependentes = null;
	private JTable jtblDependentes = null;
	private JLabel jlblContratos = null;
	private JScrollPane jscpContratos = null;
	private JTable jtblContratos = null;
	private JLabel jlblDependentesMsg = null;
	private JLabel jlblContratosMsg = null;
	private JScrollPane jscpExecucoes = null;
	private JTable jtblExecucoes = null;
	private JLabel jlblExecucoes = null;
	private JScrollPane jscpServicos = null;
	private JTable jtblServicos = null;
	private JLabel jlblServicosAsocciados = null;
	private JLabel jlblServicosAssociadosMSG = null;
	
	public BeneficiariosConsulta() {
		super();
		initialize();
	}

	private void initialize() {
		this.setSize(756, 805);
		this.setContentPane(getJContentPane());
		this.setTitle("Consulta de beneficirios");
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlblServicosAssociadosMSG = new JLabel();
			jlblServicosAssociadosMSG.setBounds(new Rectangle(497, 344, 95, 25));
			jlblServicosAssociadosMSG.setForeground(new Color(180, 51, 51));
			jlblServicosAssociadosMSG.setText("Sem servios");
			jlblServicosAssociadosMSG.setVisible(false);
			jlblServicosAsocciados = new JLabel();
			jlblServicosAsocciados.setBounds(new Rectangle(350, 342, 143, 28));
			jlblServicosAsocciados.setText("Servios associados:");
			jlblExecucoes = new JLabel();
			jlblExecucoes.setBounds(new Rectangle(21, 503, 171, 25));
			jlblExecucoes.setText("Execuces de Servios");
			jlblContratosMsg = new JLabel();
			jlblContratosMsg.setBounds(new Rectangle(89, 342, 111, 27));
			jlblContratosMsg.setForeground(new Color(180, 51, 51));
			jlblContratosMsg.setText("Sem Contrato(s)");
			jlblContratosMsg.setVisible(false);
			jlblDependentesMsg = new JLabel();
			jlblDependentesMsg.setBounds(new Rectangle(107, 191, 118, 27));
			jlblDependentesMsg.setForeground(new Color(180, 51, 51));
			jlblDependentesMsg.setText("Sem Dependente(s)");
			jlblDependentesMsg.setVisible(false);
			jlblContratos = new JLabel();
			jlblContratos.setBounds(new Rectangle(20, 343, 69, 27));
			jlblContratos.setText("Contratos:");
			jlblDependente = new JLabel();
			jlblDependente.setBounds(new Rectangle(20, 191, 88, 28));
			jlblDependente.setText("Dependentes:");
			jlblBeneficiario = new JLabel();
			jlblBeneficiario.setBounds(new Rectangle(20, 27, 97, 19));
			jlblBeneficiario.setText("Beneficirios:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlblBeneficiario, null);
			jContentPane.add(getJbtnFechar(), null);
			jContentPane.add(getJscpBeneficiario(), null);
			jContentPane.add(jlblDependente, null);
			jContentPane.add(getJscpDependentes(), null);
			jContentPane.add(jlblContratos, null);
			jContentPane.add(getJscpContratos(), null);
			jContentPane.add(jlblDependentesMsg, null);
			jContentPane.add(jlblContratosMsg, null);
			jContentPane.add(getJscpExecucoes(), null);
			jContentPane.add(jlblExecucoes, null);
			jContentPane.add(getJscpServicos(), null);
			jContentPane.add(jlblServicosAsocciados, null);
			jContentPane.add(jlblServicosAssociadosMSG, null);
		}
		return jContentPane;
	}

	private JButton getJbtnFechar() {
		if (jbtnFechar == null) {
			jbtnFechar = new JButton();
			jbtnFechar.setBounds(new Rectangle(629, 729, 89, 27));
			jbtnFechar.setText("Fechar");
			jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jbtnFechar;
	}

	private JScrollPane getJscpBeneficiario() {
		if (jscpBeneficiario == null) {
			jscpBeneficiario = new JScrollPane();
			jscpBeneficiario.setBounds(new Rectangle(20, 50, 700, 130));
			jscpBeneficiario.setViewportView(getJtblBeneficiario());
		}
		return jscpBeneficiario;
	}

	private JTable getJtblBeneficiario() {
		if (jtblBeneficiario == null) {			
			System.out.println("* Mostrar dados dos beneficirios!");
						
			Vector nomeColunas = new Vector(5);
			nomeColunas.addElement("CPF");
			nomeColunas.addElement("Nome do beneficirio");
			nomeColunas.addElement("Nmero de RG");
			nomeColunas.addElement("Endereo");
			nomeColunas.addElement("Telefone");
			
			beneficiarios = Beneficiario.getBeneficiarios();			
			DefaultTableModel modeloBeneficiarios = new DefaultTableModel(beneficiarios,nomeColunas);		
			jtblBeneficiario = new JTable(modeloBeneficiarios);
			
			// --------------------------------------------------------------------
			// Listener para a seleo de linhas
			jtblBeneficiario.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			ListSelectionModel rowSM = jtblBeneficiario.getSelectionModel();
			rowSM.addListSelectionListener(new ListSelectionListener() {
			    public void valueChanged(ListSelectionEvent e) {
			        //Outro tipos de menssagens sero no considerados.
			        if (e.getValueIsAdjusting()) return;

			        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
			        if (lsm.isSelectionEmpty()) {
			            //Nenhuma linha selecionada
			        } else {
			            int selectedRow = lsm.getMinSelectionIndex();  //selectedRow  selecionado
			            String cpf = new String();
			            cpf = (String)jtblBeneficiario.getValueAt(selectedRow,0);
			            
			            // ------------------------------------------------------------------------------
			            // Mostrar os dependentes do benebicirio
			            // System.out.println("* Mostrar beneficirios asociados para: "+cpf);			    		
			    		Vector nomeDependente = new Vector(3);
			    		nomeDependente.addElement("Nome do dependente");
			    		nomeDependente.addElement("Data de nascimento");
			    		nomeDependente.addElement("Grau de parentesco");
			    		
			    		dependentes = Dependente.getDependentes(cpf);			
			    		DefaultTableModel modeloDependentes = new DefaultTableModel(dependentes,nomeDependente);
			    		jtblDependentes.setModel(modeloDependentes);
			    		jlblDependentesMsg.setVisible(dependentes.isEmpty());
			    		
			            // ------------------------------------------------------------------------------
			            // Mostrar os contratos do benebicirio
			            // System.out.println("* Mostrar contratos do beneficirio: "+cpf);			    		
			    		Vector nomeContratos = new Vector(4);
			    		nomeContratos.addElement("Nmero");
			    		nomeContratos.addElement("Validade");
			    		nomeContratos.addElement("Mensalidade");
			    		nomeContratos.addElement("Vigente?");
			    		
			    		contratos = Contrato.getContratos(cpf);			
			    		DefaultTableModel modeloContratos = new DefaultTableModel(contratos,nomeContratos);
			    		jtblContratos.setModel(modeloContratos);	
			    		jlblContratosMsg.setVisible(contratos.isEmpty());
			    		
			    		// -------------------------------------------------------------------------------
			    		// Atualiza os dados
			    		jtblServicos.setModel(new DefaultTableModel());
			    		jtblExecucoes.setModel(new DefaultTableModel());
			        }
			    }
			});
			 
		//------------------------------            
		}		
		return jtblBeneficiario;
	}

	private JScrollPane getJscpDependentes() {
		if (jscpDependentes == null) {
			jscpDependentes = new JScrollPane();
			jscpDependentes.setBounds(new Rectangle(20, 219, 700, 100));
			jscpDependentes.setViewportView(getJtblDependentes());
		}
		return jscpDependentes;
	}

	private JTable getJtblDependentes() {
		if (jtblDependentes == null) {					
			jtblDependentes = new JTable();			
			jtblDependentes.setEnabled(false);
		}
		return jtblDependentes;
	}

	public void getDependentesCPF(String cpf){
		System.out.println("* Mostrar dados dos beneficirios!");
		
		Vector nome = new Vector(3);
		nome.addElement("Nome do dependente");
		nome.addElement("Data de nascimento");
		nome.addElement("Grau de parentesco");
		
		dependentes = Dependente.getDependentes(cpf);			
		DefaultTableModel modeloDependentes = new DefaultTableModel(dependentes,nome);		
		jtblDependentes.setModel(modeloDependentes);		
	}

	private JScrollPane getJscpContratos() {
		if (jscpContratos == null) {
			jscpContratos = new JScrollPane();
			jscpContratos.setBounds(new Rectangle(20, 370, 320, 120));
			jscpContratos.setViewportView(getJtblContratos());
		}
		return jscpContratos;
	}

	private JTable getJtblContratos() {
		if (jtblContratos == null) {
			jtblContratos = new JTable();
			
			// --------------------------------------------------------------------
			// Listener para a seleo de linhas
			jtblContratos.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			ListSelectionModel rowSM = jtblContratos.getSelectionModel();
			rowSM.addListSelectionListener(new ListSelectionListener() {
			    public void valueChanged(ListSelectionEvent e) {
			        //Outro tipos de menssagens sero no considerados.
			        if (e.getValueIsAdjusting()) return;

			        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
			        if (lsm.isSelectionEmpty()) {
			            //Nenhuma linha selecionada
			        } else {
			            int selectedRow = lsm.getMinSelectionIndex();  //selectedRow  selecionado
			            String numero = new String();
			            String cpf = new String();
			            cpf = (String)jtblBeneficiario.getValueAt(jtblBeneficiario.getSelectedRow(),0);
			            numero = (String)jtblContratos.getValueAt(selectedRow,0);
			            
			            // ------------------------------------------------------------------------------
			            // Mostrar os Servios associados			            
			    		Vector nomeServicoscontrato = new Vector(3);
			    		nomeServicoscontrato.addElement("Nome");
			    		nomeServicoscontrato.addElement("Tipo");
			    		nomeServicoscontrato.addElement("Preo");
			    		
			    		servicosContrato = Servicocontrato.getServicoscontrato(cpf, numero);			
			    		DefaultTableModel modeloServicoscontrato = new DefaultTableModel(servicosContrato,nomeServicoscontrato);
			    		jtblServicos.setModel(modeloServicoscontrato);
			    		jlblServicosAssociadosMSG.setVisible(servicosContrato.isEmpty());
			    					            
			            // ------------------------------------------------------------------------------
			            // Mostrar os servios executados
			    		// 
			    		
			    		Vector nomeServicosexecutados = new Vector(5);
			    		nomeServicosexecutados.addElement("Data");
			    		nomeServicosexecutados.addElement("Servio");
			    		nomeServicosexecutados.addElement("Dependente");
			    		nomeServicosexecutados.addElement("Centro");
			    		nomeServicosexecutados.addElement("Mdico");
			    				    		
			    		servicosExecutados = Execucaoservico.getExecucoesservico(cpf, numero);			
			    		DefaultTableModel modeloServicosexecutados = new DefaultTableModel(servicosExecutados,nomeServicosexecutados);
			    		jtblExecucoes.setModel(modeloServicosexecutados);
			    		//jlblServicosAssociadosMSG.setVisible(servicosExecutados.isEmpty());
		            
			        }
			    }
			});

			/////////////////////////////////////////////////////////////////
			
		}
		return jtblContratos;
	}

	private JScrollPane getJscpExecucoes() {
		if (jscpExecucoes == null) {
			jscpExecucoes = new JScrollPane();
			jscpExecucoes.setBounds(new Rectangle(20, 530, 699, 180));
			jscpExecucoes.setViewportView(getJtblExecucoes());
		}
		return jscpExecucoes;
	}

	private JTable getJtblExecucoes() {
		if (jtblExecucoes == null) {
			jtblExecucoes = new JTable();
		}
		return jtblExecucoes;
	}

	private JScrollPane getJscpServicos() {
		if (jscpServicos == null) {
			jscpServicos = new JScrollPane();
			jscpServicos.setBounds(new Rectangle(350, 370, 370, 120));
			jscpServicos.setViewportView(getJtblServicos());
		}
		return jscpServicos;
	}

	private JTable getJtblServicos() {
		if (jtblServicos == null) {
			jtblServicos = new JTable();
		}
		return jtblServicos;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
