package gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.Rectangle;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import gui.ExampleFileFilter;
import java.io.*;
import java.awt.Dimension;

public class CarregarXML extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jlblTitulo = null;
	private JButton jbtnAceitar = null;
	private JButton jbtnCancelar = null;
	private JComboBox jcmbTipoArquivo = null;
	private JTextField jtxtEndereco = null;
	private JLabel jlblArquivo = null;
	private JButton jbtnExplorar = null;
	private File selFile = null;

	private JButton getJbtnAceitar() {
		if (jbtnAceitar == null) {
			jbtnAceitar = new JButton();
			jbtnAceitar.setBounds(new Rectangle(124, 106, 94, 28));
			jbtnAceitar.setEnabled(false);
			jbtnAceitar.setText("Carregar");
			jbtnAceitar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					String fileType = new String();
					fileType = jcmbTipoArquivo.getSelectedItem().toString();

					LeituraArquivo processoLeve = new LeituraArquivo(selFile, fileType);
					processoLeve.start();

						
						//rpta = t1.getModoExecucao();						
						//rpta = loadBeneficiarios();
					//}
					
					
					
					/*
					if (fileType.equals("Medicos"))
						rpta = loadMedicos();
					if (fileType.equals("Contratos"))
						rpta = loadContratos();
					*/
					
					/*
					if (rpta == false) {
						JOptionPane.showMessageDialog(frame, "Formato do arquivo XML incorreto","Erro",JOptionPane.ERROR_MESSAGE);
						System.out.println("arquivo invalido!!");
					} else {					
						JOptionPane.showMessageDialog(frame, "Arquivo carregado corretamente");					
						System.out.println("* Arquivo carregado corretamente!!");
						dispose();
					}
					*/
				}	
			});
			
		}
		return jbtnAceitar;
	}

	private JButton getJbtnCancelar() {
		if (jbtnCancelar == null) {
			jbtnCancelar = new JButton();
			jbtnCancelar.setBounds(new Rectangle(257, 105, 91, 28));
			jbtnCancelar.setText("Concluir");
			jbtnCancelar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jbtnCancelar;
	}

	private JComboBox getJcmbTipoArquivo() {
		if (jcmbTipoArquivo == null) {
			jcmbTipoArquivo = new JComboBox();
			jcmbTipoArquivo.setBounds(new Rectangle(201, 14, 175, 28));
			jcmbTipoArquivo.addItem("Beneficiarios");
			jcmbTipoArquivo.addItem("Medicos");
			jcmbTipoArquivo.addItem("Contratos");
		}
		return jcmbTipoArquivo;
	}

	private JTextField getJtxtEndereco() {
		if (jtxtEndereco == null) {
			jtxtEndereco = new JTextField();
			jtxtEndereco.setBounds(new Rectangle(89, 60, 289, 27));

			jtxtEndereco
					.addCaretListener(new javax.swing.event.CaretListener() {
						public void caretUpdate(javax.swing.event.CaretEvent e) {
							if (jtxtEndereco.getText().equals(""))
								jbtnAceitar.setEnabled(false);
							else
								jbtnAceitar.setEnabled(true);
						}
					});
		}
		return jtxtEndereco;
	}

	private JButton getJbtnExplorar() {
		if (jbtnExplorar == null) {
			jbtnExplorar = new JButton();
			jbtnExplorar.setBounds(new Rectangle(391, 61, 97, 28));
			jbtnExplorar.setText("Selecionar");
			jbtnExplorar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFrame frame = new JFrame();
					JFileChooser fc = new JFileChooser();
					ExampleFileFilter filter = new ExampleFileFilter();
					filter.addExtension("xml");
					filter.setDescription("Somente arquivos XML");
					fc.setFileFilter(filter);
					
				    int returnVal = fc.showOpenDialog(frame);				    
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
					       System.out.println("* Arquivo escolhido: "+fc.getSelectedFile().getName());
					       selFile = fc.getSelectedFile();	
					       jtxtEndereco.setText(selFile.getAbsolutePath());					}
				    else {
				    	JOptionPane.showMessageDialog(frame,"Arquivo no foi selecionado");			    	
				    }
				}
			});
		}
		return jbtnExplorar;
	}

	public CarregarXML() {
		super();
		initialize();
	}

	private void initialize() {
		this.setSize(507, 184);
		this.setContentPane(getJContentPane());
		this.setTitle("Carga de dados de arquivos XML");
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlblArquivo = new JLabel();
			jlblArquivo.setBounds(new Rectangle(20, 57, 61, 28));
			jlblArquivo.setText("Arquivo :");
			jlblTitulo = new JLabel();
			jlblTitulo.setBounds(new Rectangle(19, 14, 124, 29));
			jlblTitulo.setText("Tipo de arquivo XML :");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlblTitulo, null);
			jContentPane.add(getJbtnAceitar(), null);
			jContentPane.add(getJbtnCancelar(), null);
			jContentPane.add(getJcmbTipoArquivo(), null);
			jContentPane.add(getJtxtEndereco(), null);
			jContentPane.add(jlblArquivo, null);
			jContentPane.add(getJbtnExplorar(), null);
		}
		return jContentPane;
	}

	
} // @jve:decl-index=0:visual-constraint="10,10"
