package gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.Rectangle;
import java.util.Vector;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import logic.Contrato;
import logic.Execucaoservico;


public class ClassificacaoContratos extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jlblContratos = null;
	private JScrollPane jscpClassificacao = null;
	private JTable jtblClassificacao = null;
	private JButton jbtnFechar = null;
	private Vector classificacao;  //  @jve:decl-index=0:
	private Vector consultamensal;
	private Vector consultamensaldetalhe;
	private JScrollPane jscpClassificacaoDeficitaria = null;
	private JTable jtblClassificacaoDeficitaria = null;
	private JLabel jlblClassificacao = null;
	private JScrollPane jscpConsultaMes = null;
	private JTable jtblConsultaMes = null;
	private JLabel jlblConsultaMes = null;
	private JScrollPane jscpConsultaMesDetalhe = null;
	private JTable jtblConsultaMesDetalhe = null;
	private String cpf=null;
	private String numero=null;
	private JLabel jlblDetalheGasto = null;

	public ClassificacaoContratos() {
		super();
		initialize();
	}
	
	private void initialize() {
		this.setSize(802, 627);
		this.setContentPane(getJContentPane());
		this.setTitle("Classificao de contratos");
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlblDetalheGasto = new JLabel();
			jlblDetalheGasto.setBounds(new Rectangle(240, 340, 139, 23));
			jlblDetalheGasto.setText("Detalhe gasto no ms:");
			jlblConsultaMes = new JLabel();
			jlblConsultaMes.setBounds(new Rectangle(22, 341, 149, 23));
			jlblConsultaMes.setText("Valor gasto por ms:");
			jlblClassificacao = new JLabel();
			jlblClassificacao.setBounds(new Rectangle(20, 179, 149, 20));
			jlblClassificacao.setText("Contratos deficitrios:");
			jlblContratos = new JLabel();
			jlblContratos.setBounds(new Rectangle(20, 23, 189, 21));
			jlblContratos.setText("Contratos no deficitrios:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlblContratos, null);
			jContentPane.add(getJscpClassificacao(), null);
			jContentPane.add(getJbtnFechar(), null);
			jContentPane.add(getJscpClassificacaoDeficitaria(), null);
			jContentPane.add(jlblClassificacao, null);
			jContentPane.add(getJscpConsultaMes(), null);
			jContentPane.add(jlblConsultaMes, null);
			jContentPane.add(getJscpConsultaMesDetalhe(), null);
			jContentPane.add(jlblDetalheGasto, null);
		}
		return jContentPane;
	}

	private JScrollPane getJscpClassificacao() {
		if (jscpClassificacao == null) {
			jscpClassificacao = new JScrollPane();
			jscpClassificacao.setBounds(new Rectangle(20, 45, 750, 120));
			jscpClassificacao.setViewportView(getJtblClassificacao());
		}
		return jscpClassificacao;
	}

	private JTable getJtblClassificacao() {
		if (jtblClassificacao == null) {
						
			//-------------------------------------------------
			Vector nomeColunas = new Vector(5);
			nomeColunas.addElement("CPF");
			nomeColunas.addElement("Contrato");
			nomeColunas.addElement("Validade");
			nomeColunas.addElement("Beneficiario");
			nomeColunas.addElement("Mensalidade");
			nomeColunas.addElement("Total");
			
			classificacao = Contrato.getClassificacao(true);			
			DefaultTableModel modeloBeneficiarios = new DefaultTableModel(classificacao,nomeColunas);		
			jtblClassificacao = new JTable(modeloBeneficiarios);		

			// --------------------------------------------------------------------
			// Listener para a seleo de linhas
			jtblClassificacao.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			ListSelectionModel rowSM = jtblClassificacao.getSelectionModel();
			rowSM.addListSelectionListener(new ListSelectionListener() {
			    public void valueChanged(ListSelectionEvent e) {
			        //Outro tipos de menssagens sero no considerados.
			        if (e.getValueIsAdjusting()) return;

			        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
			        if (lsm.isSelectionEmpty()) {
			            //Nenhuma linha selecionada
			        } else {
			            int selectedRow = lsm.getMinSelectionIndex();  //selectedRow  selecionado
			            
			            cpf    = (String)jtblClassificacao.getValueAt(selectedRow,0);
			            numero = (String)jtblClassificacao.getValueAt(selectedRow,1);
			            
			            // ------------------------------------------------------------------------------
			            // Mostrar a quantidade gasta agrupado por ms    		
			    		Vector nomeContratos = new Vector(3);
			    		nomeContratos.addElement("Ao");
			    		nomeContratos.addElement("Mes");
			    		nomeContratos.addElement("Total");
			    		
			    		consultamensal = Contrato.getClassificacaoMensal(cpf, numero);			
			    		DefaultTableModel modeloConsultamensal = new DefaultTableModel(consultamensal,nomeContratos);
			    		jtblConsultaMes.setModel(modeloConsultamensal);	 
			    		jtblClassificacaoDeficitaria.clearSelection();
			    		jtblConsultaMesDetalhe.setModel(new DefaultTableModel());			
			    					    	
			        }
			    }
			});
			//--------------------------------------------------------------------------------------------			
		}
		return jtblClassificacao;
	}

	private JButton getJbtnFechar() {
		if (jbtnFechar == null) {
			jbtnFechar = new JButton();
			jbtnFechar.setBounds(new Rectangle(670, 551, 98, 25));
			jbtnFechar.setText("Fechar");
			jbtnFechar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jbtnFechar;
	}

	private JScrollPane getJscpClassificacaoDeficitaria() {
		if (jscpClassificacaoDeficitaria == null) {
			jscpClassificacaoDeficitaria = new JScrollPane();
			jscpClassificacaoDeficitaria.setBounds(new Rectangle(20, 200, 750, 120));
			jscpClassificacaoDeficitaria.setViewportView(getJtblClassificacaoDeficitaria());
		}
		return jscpClassificacaoDeficitaria;
	}

	private JTable getJtblClassificacaoDeficitaria() {
		if (jtblClassificacaoDeficitaria == null) {
			//-------------------------------------------------
			Vector nomeColunas = new Vector(5);
			nomeColunas.addElement("CPF");
			nomeColunas.addElement("Contrato");
			nomeColunas.addElement("Validade");
			nomeColunas.addElement("Beneficiario");
			nomeColunas.addElement("Mensalidade");
			nomeColunas.addElement("Total");
			
			classificacao = Contrato.getClassificacao(false);			
			DefaultTableModel modeloBeneficiarios = new DefaultTableModel(classificacao,nomeColunas);		
			jtblClassificacaoDeficitaria = new JTable(modeloBeneficiarios);		
		
			// --------------------------------------------------------------------
			// Listener para a seleo de linhas
			jtblClassificacaoDeficitaria.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			ListSelectionModel rowSM = jtblClassificacaoDeficitaria.getSelectionModel();
			rowSM.addListSelectionListener(new ListSelectionListener() {
			    public void valueChanged(ListSelectionEvent e) {
			        //Outro tipos de menssagens sero no considerados.
			        if (e.getValueIsAdjusting()) return;

			        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
			        if (lsm.isSelectionEmpty()) {
			            //Nenhuma linha selecionada
			        } else {
			            int selectedRow = lsm.getMinSelectionIndex();  //selectedRow  selecionado
			            
			            cpf    = (String)jtblClassificacaoDeficitaria.getValueAt(selectedRow,0);
			            numero = (String)jtblClassificacaoDeficitaria.getValueAt(selectedRow,1);
			            
			            // ------------------------------------------------------------------------------
			            // Mostrar a quantidade gasta agrupado por ms    		
			    		Vector nomeContratos = new Vector(3);
			    		nomeContratos.addElement("Ao");
			    		nomeContratos.addElement("Mes");
			    		nomeContratos.addElement("Total");
			    		
			    		consultamensal = Contrato.getClassificacaoMensal(cpf, numero);			
			    		DefaultTableModel modeloConsultamensal = new DefaultTableModel(consultamensal,nomeContratos);
			    		jtblConsultaMes.setModel(modeloConsultamensal);	 
			    		jtblClassificacao.clearSelection();
			    		jtblConsultaMesDetalhe.setModel(new DefaultTableModel());
			    					    	
			        }
			    }
			});
			//--------------------------------------------------------------------------------------------			
			//jtblClassificacaoDeficitaria = new JTable();
		}
		return jtblClassificacaoDeficitaria;
	}

	private JScrollPane getJscpConsultaMes() {
		if (jscpConsultaMes == null) {
			jscpConsultaMes = new JScrollPane();
			jscpConsultaMes.setBounds(new Rectangle(20, 367, 200, 160));
			jscpConsultaMes.setViewportView(getJtblConsultaMes());
		}
		return jscpConsultaMes;
	}

	private JTable getJtblConsultaMes() {
		if (jtblConsultaMes == null) {
			jtblConsultaMes = new JTable();

			// --------------------------------------------------------------------
			// Listener para a seleo de linhas
			jtblConsultaMes.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			ListSelectionModel rowSM = jtblConsultaMes.getSelectionModel();
			rowSM.addListSelectionListener(new ListSelectionListener() {
			    public void valueChanged(ListSelectionEvent e) {
			        //Outro tipos de menssagens sero no considerados.
			        if (e.getValueIsAdjusting()) return;

			        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
			        if (lsm.isSelectionEmpty()) {
			            //Nenhuma linha selecionada
			        } else {
			            int selectedRow = lsm.getMinSelectionIndex();  //selectedRow  selecionado			            
			            String ano = (String)jtblConsultaMes.getValueAt(selectedRow,0);
			            String mes = (String)jtblConsultaMes.getValueAt(selectedRow,1);

			            // ------------------------------------------------------------------------------
			            // Mostrar a detalhe dos servios usados no ms    		
			    		Vector nomeExecucoes = new Vector(4);
			    		nomeExecucoes.addElement("Data");
			    		nomeExecucoes.addElement("Servio");
			    		nomeExecucoes.addElement("Tarifa");
			    		nomeExecucoes.addElement("Centro Mdico");
			    		
			    		consultamensaldetalhe = Execucaoservico.getExecucoesservicoMensal(cpf, numero, ano, mes);			
			    		DefaultTableModel modeloConsultamensaldetalhe = new DefaultTableModel(consultamensaldetalhe,nomeExecucoes);
			    		jtblConsultaMesDetalhe.setModel(modeloConsultamensaldetalhe);	 
			    		//jtblClassificacao.clearSelection();
			    					    	
			        }
			    }
			});
			//--------------------------------------------------------------------------------------------			

		}
		return jtblConsultaMes;
	}

	private JScrollPane getJscpConsultaMesDetalhe() {
		if (jscpConsultaMesDetalhe == null) {
			jscpConsultaMesDetalhe = new JScrollPane();
			jscpConsultaMesDetalhe.setBounds(new Rectangle(240, 367, 530, 160));
			jscpConsultaMesDetalhe.setViewportView(getJtblConsultaMesDetalhe());
		}
		return jscpConsultaMesDetalhe;
	}

	private JTable getJtblConsultaMesDetalhe() {
		if (jtblConsultaMesDetalhe == null) {
			jtblConsultaMesDetalhe = new JTable();
		}
		return jtblConsultaMesDetalhe;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
