package gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class InterfacePrincipal extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				InterfacePrincipal thisClass = new InterfacePrincipal();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}
	
	public InterfacePrincipal() {
		super();
		initialize();
	}

	private void initialize() {
		this.setSize(803, 379);
		this.setContentPane(getJContentPane());
		this.setTitle("Administradora de Servios Mdicos");
		
		//------------------------------------------------------------------
		JMenuBar menuBar = new JMenuBar();
		JMenu menuSistema = new JMenu("Sistema");
		JMenu menuConsulta = new JMenu("Consulta");
		JMenu menuAjuda = new JMenu("Ajuda");
	    
	    ActionListener printListener = new ActionListener(  ) {
	         public void actionPerformed(ActionEvent event) {
	        	 
	        	 if(event.getActionCommand().equalsIgnoreCase("carregar arquivo xml")) {
	        			CarregarXML carregarxml = new CarregarXML();
	        			carregarxml.setVisible(true);
	        	 }	        	 
	        	 
	        	 if(event.getActionCommand().equalsIgnoreCase("beneficirios")) {
	        			BeneficiariosConsulta beneficiariosconsulta = new BeneficiariosConsulta();
	        			beneficiariosconsulta.setVisible(true);
	        	 }
	        	 
	        	 if(event.getActionCommand().equalsIgnoreCase("classificao de contratos")) {
	        			ClassificacaoContratos classificacaocontratos = new ClassificacaoContratos();
	        			classificacaocontratos.setVisible(true);
	        	 }

	        	 if(event.getActionCommand().equalsIgnoreCase("sobre o programa")) {
	        		 JOptionPane.showMessageDialog(getJContentPane(), 
	        				 "MAC5853: Desenvolvimento de Sistemas de Computao\n2006-1\n\nAluno: Jess Mena-Chalco\njmena@vision.ime.usp.br",
	        				 "Sobre o programa",
	        				 JOptionPane.INFORMATION_MESSAGE);	        			
	        	 }
	        	 
	        	 if(event.getActionCommand().equalsIgnoreCase("sair")) {
	        		 dispose();
	        	 }
	         }
	    };
	      
	    JMenuItem item;
	      
	    // Menu: sistema
	    item = new JMenuItem("Carregar arquivo XML");
	    item.addActionListener(printListener);
	    menuSistema.add(item);
	      	      
	    menuSistema.insertSeparator(2);	      
	    item = new JMenuItem("Sair");
	    item.addActionListener(printListener);
	    menuSistema.add(item);
	      
	    // Menu: Consulta
	    item = new JMenuItem("Beneficirios");
	    item.addActionListener(printListener);
	    menuConsulta.add(item);
	      
	    item = new JMenuItem("Classificao de contratos");
	    item.addActionListener(printListener);
	    menuConsulta.add(item);
	          
	    // Ajuda
	    item = new JMenuItem("Sobre o programa");
	    item.addActionListener(printListener);
	    menuAjuda.add(item);	      

	    // Acrescentamos os menus
	    menuBar.add(menuSistema);
	    menuBar.add(menuConsulta);
	    menuBar.add(menuAjuda);
		
		this.setJMenuBar(menuBar);		
		//------------------------------------------------------------------		
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
		}
		return jContentPane;
	}
}