package gui;

import java.io.File;
import java.io.FileReader;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import logic.Beneficiario;
import logic.Contrato;
import logic.Dependente;
import logic.Especialidademedico;
import logic.Execucaoservico;
import logic.Medico;
import logic.Servicocontrato;
import gui.RelatorioLeitura;
import xml.*;


import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class LeituraArquivo extends Thread {
	private File selFile;
	private String tipo;

	// Construtor
	public LeituraArquivo(File selFile, String tipo){
		this.selFile = selFile;
		this.tipo = tipo;
	}
			
	public synchronized void run() {
		Boolean rpta = new Boolean(false);
		
		if (tipo.equalsIgnoreCase("beneficiarios")) 
			rpta = loadBeneficiarios();
		if (tipo.equalsIgnoreCase("medicos"))
			rpta = loadMedicos();
		if (tipo.equalsIgnoreCase("contratos"))
			rpta = loadContratos();
		
		try {
			sleep((int)(Math.random()*10000));
		}
		catch(InterruptedException e) {
			System.out.println("Thread: interrompida");
		}		
	
		if (rpta == false) {
			RelatorioLeitura relatorioleitura = new RelatorioLeitura("Formato do arquivo XML incorreto para a opo:\n"+tipo,selFile.getAbsolutePath());
			relatorioleitura.setVisible(true);			
			System.out.println("arquivo invalido!!");
		} else {					
			RelatorioLeitura relatorioleitura = new RelatorioLeitura("Arquivo carregado corretamente para a opo:\n"+tipo,selFile.getAbsolutePath());
			relatorioleitura.setVisible(true);			
			System.out.println("* Arquivo carregado corretamente!!");
		}				
	}	
	
	protected synchronized Boolean loadBeneficiarios() {
		System.out.println("* TIPO DE ARQUIVO XML: beneficiarios");
		System.out.println("* Arquivo selecionado: "+ selFile.getAbsolutePath());

		XStream xmlLoader = new XStream(new DomDriver());
		xmlLoader.alias("beneficiario", Beneficiario.class);
		xmlLoader.alias("dependente", Dependente.class);
		xmlLoader.alias("root", BeneficiarioXMLProc.class);

		try {
			BeneficiarioXMLProc beneficiarioXML = (BeneficiarioXMLProc) xmlLoader.fromXML(new FileReader(selFile));
			beneficiarioXML.enviarAoBD();			
			System.out.println("+++ Arquivo de Beneficirios carregado: "+selFile.getAbsolutePath());
			return true;			
		} catch (Exception ex) {
			System.out.println("+++ Arquivo de Beneficirios con problemas: "+selFile.getAbsolutePath());
			return false;
		}
	}

	protected synchronized Boolean loadMedicos() {
		System.out.println("* TIPO DE ARQUIVO XML: medicos");
		System.out.println("* Arquivo selecionado: "+ selFile.getAbsolutePath());

		XStream xmlLoader = new XStream(new DomDriver());
		xmlLoader.alias("medico", Medico.class);
		xmlLoader.alias("especialidademedico", Especialidademedico.class);
		xmlLoader.alias("root", MedicoXMLProc.class);

		try {
			MedicoXMLProc medicoXML = (MedicoXMLProc) xmlLoader.fromXML(new FileReader(selFile));
			medicoXML.enviarAoBD();
			System.out.println("+++ Arquivo de Mdicos carregado: "+selFile.getAbsolutePath());
			return true;
		} catch (Exception ex) {
			System.out.println("+++ Arquivo de Mdicos con problemas: "+selFile.getAbsolutePath());
			return false;
		}
	}

	protected synchronized Boolean loadContratos() {
		System.out.println("* TIPO DE ARQUIVO XML: contratos");
		System.out.println("* Arquivo selecionado: "+selFile.getAbsolutePath());

		XStream xmlLoader = new XStream(new DomDriver());
		xmlLoader.alias("contrato", Contrato.class);
		xmlLoader.alias("servicocontrato", Servicocontrato.class);
		xmlLoader.alias("execucaoservico", Execucaoservico.class);
		xmlLoader.alias("root", ContratoXMLProc.class);

		try {
			ContratoXMLProc contratoXML = (ContratoXMLProc) xmlLoader.fromXML(new FileReader(selFile));
			contratoXML.enviarAoBD();
			System.out.println("+++ Arquivo de Contratos carregado: "+selFile.getAbsolutePath());
			return true;
		} catch (Exception ex) {
			System.out.println("+++ Arquivo de Contratos con problemas: "+selFile.getAbsolutePath());
			return false;
		}
	}	
}