package logic;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import java.util.Date;

import db.BDacesso;

public class Contrato {
	public String numero;
	public String cpfbeneficiario;
	public String datavalidade;
	public String valormensalidade;
	
	public static Vector getContratos(String cpf) {
		Vector contratos = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT numero,data_validade,valor_mensalidade FROM contrato "+
		               "WHERE cpf_beneficiario="+cpf+" ORDER BY numero";
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			Date data = new Date();
						
			do {
				Vector linha = new Vector();
				rs.next();
				
				linha.addElement(rs.getString("numero"));		
				linha.addElement(rs.getString("data_validade"));
				linha.addElement(rs.getString("valor_mensalidade"));							
				linha.addElement(data.before(rs.getDate("data_validade"))?"Sim":"No");			
				contratos.addElement(linha);
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sem contratos!.");
		}	
		dbAcesso.fecharConecao();
		return contratos;
	}

	public static Vector getClassificacaoMensal(String cpf, String numero) {
		Vector contratos = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT date_part('year',ex.data) AS ano, date_part('month',ex.data) AS mes, sum(s.valor) as total_gasto "+
					   "FROM beneficiario b, contrato c, servico s, servico_contrato sc, execucao_servico ex "+
					   "WHERE "+
					   "c.numero='"+numero+"' AND "+
					   "b.cpf="+cpf+" AND "+
					   "c.numero=sc.numero_contrato AND "+
					   "c.cpf_beneficiario=sc.cpf_beneficiario AND "+
					   "s.codigo=sc.codigo_servico AND "+
					   "sc.numero_contrato=ex.numero_contrato AND "+
					   "sc.cpf_beneficiario=ex.cpf_beneficiario AND "+
					   "sc.codigo_servico=ex.codigo_servico AND "+
					   "b.cpf=c.cpf_beneficiario "+
					   "GROUP BY ano, mes, c.numero, cpf, c.data_validade "+
					   "ORDER BY ano, mes";
			
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			Date data = new Date();
						
			do {
				Vector linha = new Vector();
				rs.next();
				
				linha.addElement(rs.getString("ano"));		
				linha.addElement(rs.getString("mes"));
				linha.addElement(rs.getString("total_gasto"));						
				contratos.addElement(linha);
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sem Servios executados!.");
		}	
		dbAcesso.fecharConecao();
		return contratos;
	}

	public static Vector getClassificacao(Boolean tipo) {
		// Tipo: 
		//      true:  no deficitrio  :-)
		//      false: deficitrio      :-(
		Vector classificacao = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
		String operacao = tipo.booleanValue() ? "<=" : ">";
		
		instrucaoSQL = "SELECT b.cpf AS cpf, c.numero AS contrato, c.data_validade, b.nome AS beneficiario, "+
                       "c.valor_mensalidade AS mensalidade, sum(s.valor) as total_gasto " +
                       "FROM beneficiario b, contrato c, servico s, servico_contrato sc, execucao_servico ex "+
                       "WHERE "+
                       "c.numero=sc.numero_contrato AND "+
                       "c.cpf_beneficiario=sc.cpf_beneficiario AND "+
                       "s.codigo=sc.codigo_servico AND "+
                       "sc.numero_contrato=ex.numero_contrato AND "+
                       "sc.cpf_beneficiario=ex.cpf_beneficiario AND "+
                       "sc.codigo_servico=ex.codigo_servico AND "+
                       "b.cpf=c.cpf_beneficiario "+
                       "GROUP BY cpf, c.numero, c.data_validade, beneficiario, c.valor_mensalidade "+
                       "HAVING sum(s.valor)"+operacao+"c.valor_mensalidade*3 "+
                       "ORDER BY 1";
		
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
								
			do {
				Vector linha = new Vector();
				rs.next();
				
				linha.addElement(rs.getString("cpf"));
				linha.addElement(rs.getString("contrato"));
				linha.addElement(rs.getString("data_validade"));
				linha.addElement(rs.getString("beneficiario"));
				linha.addElement(rs.getString("mensalidade"));
				linha.addElement(rs.getString("total_gasto"));							
				classificacao.addElement(linha);
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sem execues realizadas at agora!.");
		}	
		dbAcesso.fecharConecao();
		return classificacao;
	}
	
	
	public String getNumero() {
		return numero;
	}
	protected void setNumero(String numero) {
		this.numero = numero;
	}
	
	public String getCpfbeneficiario() {
		return cpfbeneficiario;
	}
	protected void setCpfbeneficiario(String cpfbeneficiario) {
		this.cpfbeneficiario = cpfbeneficiario;
	}
	
	public String getDatavalidade() {
		return datavalidade;
	}
	protected void setDatavalidade(String datavalidade) {
		this.datavalidade = datavalidade;
	}
	
	public String getValormensalidade() {
		return valormensalidade;
	}
	protected void setValormensalidade(String valormensalidade) {
		this.valormensalidade = valormensalidade;
	}
	
	
	public void enviarAoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT numero,cpf_beneficiario FROM contrato WHERE numero="+numero+" AND cpf_beneficiario="+cpfbeneficiario;
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			rs.next();
			
			if (rs.isLast()){
				//if(this.cpf.equals(rs.getString("cpf")))
				atualizarNoBD();
			}
			else { 			
				inserirNoBD();
			}						
		} catch(SQLException se){
			System.out.println("- Ocorreu um erro enviando os dados ao banco de dados.");
			se.printStackTrace();
			//System.exit(1);
		}
	}

	private void inserirNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "INSERT INTO contrato (numero,cpf_beneficiario,data_validade,valor_mensalidade) "+
		               "VALUES("+numero+","+cpfbeneficiario+",'"+datavalidade+"',"+valormensalidade+")";
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);		
	}

	private void atualizarNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "UPDATE contrato SET "+
		               "data_validade='"+datavalidade+"',"+
		               "valor_mensalidade="+valormensalidade+" "+
		               "WHERE numero="+numero+" AND cpf_beneficiario="+cpfbeneficiario;
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
	}
}