package logic;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;


import db.BDacesso;

public class Dependente {
	public String codigo;
	public String nome;
	public String cpfbeneficiario;
	public String datanascimento;
	public String grauparentesco;
	
	public static Vector getDependentes(String cpf) {
		Vector dependentes = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT nome,data_nascimento,grau_parentesco "+
		               "FROM dependente WHERE cpf_beneficiario="+cpf+" ORDER BY nome";
						
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			do {
				Vector linha = new Vector();
				rs.next();
		
				linha.addElement(rs.getString("nome"));		
				linha.addElement(rs.getString("data_nascimento"));
				linha.addElement(rs.getString("grau_parentesco"));
				dependentes.addElement(linha);
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sem dependentes!");
		}	
		dbAcesso.fecharConecao();
		return dependentes;
	}
	
	public static String getNome(String codigo, String cpf) {		
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();		
		instrucaoSQL = "SELECT nome FROM dependente WHERE codigo='"+codigo+"' AND cpf_beneficiario="+cpf;						
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();			
			rs.next();
			return rs.getString("nome");								
		} catch (SQLException se) {
			return "-";
		}			
	}
		
	public String getCodigo() {
		return codigo;
	}
	
	protected void setCodigo(String codigo) {
		this.codigo = codigo;
	}
	
	public String getNome() {
		return nome;
	}
	
	protected void setNome(String nome) {
		this.nome = nome;
	}

	public void enviarAoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT codigo FROM dependente WHERE codigo="+codigo;
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			rs.next();
			
			if (rs.isLast()){			
				//if(this.codigo.equalsIgnoreCase(rs.getString("codigo")) ) 
				atualizarNoBD();				
			}
			else {
				inserirNoBD();
			}						
		} catch(SQLException se){
			System.out.println("- Ocorreu um erro enviando os dados ao banco de dados.");
			se.printStackTrace();
			//System.exit(1);
		}
		bdAcesso.fecharConecao();
	}

	private void inserirNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
				
		instrucaoSQL = "INSERT INTO dependente (codigo,nome,cpf_beneficiario,data_nascimento,grau_parentesco) "+
		               "VALUES("+codigo+",'"+nome+"',"+cpfbeneficiario+",'"+datanascimento+"','"+grauparentesco+"')";
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
		bdAcesso.fecharConecao();
	}

	private void atualizarNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "UPDATE dependente SET "+
		               "nome='"+nome+"',"+
		               "cpf_beneficiario="+cpfbeneficiario+","+
		               "data_nascimento='"+datanascimento+"',"+
		               "grau_parentesco='"+grauparentesco+"' "+
		               "WHERE codigo="+codigo;
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
		bdAcesso.fecharConecao();
	}
}
