package logic;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import db.BDacesso;

public class Execucaoservico {
	public String numerocontrato;
	public String cpfbeneficiario;
	public String codigoservico;
	public String numeroexecucao;	
	public String data;
	public String cgccentromedico;
	public String cpfmedico;
	public String codigodependente;
	
	public static Vector getExecucoesservico(String cpf, String numero) {
		Vector execucoesservico = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		//----------------------
		// Comprovar que exista beneficiario com esses dados
		
		
		/*
		instrucaoSQL = "SELECT ex.data AS data, s.descricao AS servico, d.nome AS dependente, cm.nome AS centro, m.nome AS medico "+
		               "FROM execucao_servico ex, medico m, centro_medico cm, dependente d, servico_contrato sc, servico s "+
		               "WHERE "+
		               "sc.numero_contrato='"+numero+"' AND "+
		               "sc.cpf_beneficiario="+cpf+" AND "+
		               "sc.codigo_servico=ex.codigo_servico AND "+
		               "sc.numero_contrato=ex.numero_contrato AND "+
		               "sc.cpf_beneficiario=ex.cpf_beneficiario AND "+
		               "sc.codigo_servico=s.codigo AND "+
		               "ex.cgc_centro_medico=cm.cgc AND "+
		               "ex.cpf_medico=m.cpf AND "+
		               "(ex.codigo_dependente=d.codigo OR ex.codigo_dependente='') "+
		               "ORDER BY data";
		 */
		
		instrucaoSQL = "SELECT ex.data AS data, s.descricao AS servico, ex.codigo_dependente AS dependente, cm.nome AS centro, m.nome AS medico "+
				       "FROM execucao_servico ex, medico m, centro_medico cm, servico_contrato sc, servico s "+
				       "WHERE "+
				       "sc.numero_contrato='"+numero+"' AND "+
				       "sc.cpf_beneficiario="+cpf+" AND "+
				       "sc.codigo_servico=ex.codigo_servico AND "+
				       "sc.numero_contrato=ex.numero_contrato AND "+
				       "sc.cpf_beneficiario=ex.cpf_beneficiario AND "+
				       "sc.codigo_servico=s.codigo AND "+
				       "ex.cgc_centro_medico=cm.cgc AND "+
				       "ex.cpf_medico=m.cpf "+
				       "ORDER BY data";

		
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			do {
				Vector linha = new Vector();				
				rs.next();
						
				linha.addElement(rs.getString("data"));
				linha.addElement(rs.getString("servico"));
				linha.addElement( Dependente.getNome(rs.getString("dependente"),cpf) );
				linha.addElement(rs.getString("centro"));
				linha.addElement(rs.getString("medico"));																	
				execucoesservico.addElement(linha);				
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sim servioes executados.");
		}	
		dbAcesso.fecharConecao();
		return execucoesservico;
	}
	
	public static Vector getExecucoesservicoMensal(String cpf, String numero, String ano, String mes) {
		Vector execucoesservico = new Vector();
		BDacesso dbAcesso = new BDacesso();
		String instrucaoSQL = new String();
				
		instrucaoSQL = "SELECT ex.data AS data, s.valor as costo, s.descricao AS servico, cm.nome AS centro "+
		               "FROM execucao_servico ex, centro_medico cm, servico_contrato sc, servico s "+
		               "WHERE "+
		               "sc.numero_contrato='"+numero+"' AND "+
		               "sc.cpf_beneficiario="+cpf+" AND "+
		               "date_part('year',ex.data)='"+ano+"' AND "+
		               "date_part('month',ex.data)='"+mes+"' AND "+
		               "sc.codigo_servico=ex.codigo_servico AND "+
		               "sc.numero_contrato=ex.numero_contrato AND "+
		               "sc.cpf_beneficiario=ex.cpf_beneficiario AND "+
		               "sc.codigo_servico=s.codigo AND "+
		               "ex.cgc_centro_medico=cm.cgc "+
		               "ORDER BY data";
				
		Statement stmt= dbAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			do {
				Vector linha = new Vector();				
				rs.next();
						
				linha.addElement(rs.getString("data"));
				linha.addElement(rs.getString("servico"));
				linha.addElement(rs.getString("costo"));
				linha.addElement(rs.getString("centro"));																	
				execucoesservico.addElement(linha);				
				
			} while(!rs.isLast());			
		} catch (SQLException se) {
			System.out.println("* Sim servioes executados.");
		}	
		dbAcesso.fecharConecao();
		return execucoesservico;
	}
		
	/*public String getNumero() {
		return numero;
	}
	protected void setNumero(String numero) {
		this.numero = numero;
	}*/
	
	public void enviarAoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "SELECT numero_contrato,cpf_beneficiario,codigo_servico,numero_execucao,data,cgc_centro_medico,cpf_medico,codigo_dependente "+
		               "FROM execucao_servico WHERE "+
		               "numero_contrato='"+numerocontrato+"' AND "+
		               "cpf_beneficiario="+cpfbeneficiario+" AND "+
		               "codigo_servico='"+codigoservico+"' AND "+
		               "numero_execucao='"+numeroexecucao+"'";
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
		
		try{
			ResultSet rs = stmt.getResultSet();
			rs.next();
			
			if (rs.isLast()){
				//if(this.cpf.equals(rs.getString("cpf")))
				atualizarNoBD();
			}
			else { 			
				inserirNoBD();
			}						
		} catch(SQLException se){
			System.out.println("- Ocorreu um erro enviando os dados ao banco de dados.");
			se.printStackTrace();
			//System.exit(1);
		}
	}

	private void inserirNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "INSERT INTO execucao_servico (numero_contrato,cpf_beneficiario,codigo_servico,numero_execucao,data,cgc_centro_medico,cpf_medico,codigo_dependente) "+
		               "VALUES('"+numerocontrato+"',"+cpfbeneficiario+",'"+codigoservico+"','"+numeroexecucao+"','"+data+"','"+cgccentromedico+"',"+cpfmedico+",'"+codigodependente+"')";
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);		
	}

	private void atualizarNoBD() {
		BDacesso bdAcesso = new BDacesso();
		String instrucaoSQL = new String();
		
		instrucaoSQL = "UPDATE execucao_servico SET "+
		               "numero_contrato='"+numerocontrato+"',"+
					   "cpf_beneficiario="+cpfbeneficiario+","+
					   "codigo_servico='"+codigoservico+"',"+
					   "numero_execucao='"+numeroexecucao+"',"+
					   "data='"+data+"',"+
					   "cgc_centro_medico='"+cgccentromedico+"',"+
					   "cpf_medico="+cpfmedico+","+
					   "codigo_dependente='"+codigodependente+"' "+					 
		               "WHERE "+
		               "numero_contrato='"+numerocontrato+"' AND "+
		               "cpf_beneficiario="+cpfbeneficiario+" AND "+
		               "codigo_servico='"+codigoservico+"' AND "+
		               "numero_execucao='"+numeroexecucao+"'";		
		Statement stmt = bdAcesso.executarInstrucaoSQL(instrucaoSQL);
	}
}